#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec-vm
Version:	4.2.6
Release:	1%{dist}
Summary:	The Qubes qrexec files (qube side)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:	pam-devel
BuildRequires:	pandoc
BuildRequires:	qubes-libvchan-devel
BuildRequires:	qubes-core-qrexec-devel
BuildRequires:	lsb-core-noarch
BuildRequires:	systemd-devel

Requires:   python%{python3_pkgversion}
Requires:   qubes-core-qrexec = %{version}-%{release}

Provides:   qubes-core-agent-qrexec = 4.1.0-1
Obsoletes:  qubes-core-agent-qrexec < 4.1.0-1

Source0: qubes-core-qrexec-%{version}.tar.gz

Requires: (%{name}-selinux if selinux-policy)

%package selinux
BuildRequires: selinux-policy
BuildRequires: selinux-policy-devel
%{?selinux_requires}
Requires(post): qubes-core-agent-selinux
Summary: SELinux policies for qrexec
License: GPLv2+

%description selinux
The SELinux policies for qrexec.  You need this package if you want to have
SELinux enforcing in a qube.

%description
The Qubes qrexec files for installation on a qube.

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-vm all-vm-selinux
#make -C doc PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} man

%install
make install-vm install-vm-selinux \
    DESTDIR=$RPM_BUILD_ROOT \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    SYSCONFDIR=%{_sysconfdir}

#make -C doc DESTDIR=$RPM_BUILD_ROOT \
#    PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} \
#    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%post
%systemd_post qubes-qrexec-agent.service

%preun
%systemd_preun qubes-qrexec-agent.service

%post selinux
%selinux_modules_install %{_datadir}/selinux/packages/qubes-core-qrexec.pp || :

%postun selinux
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-core-qrexec.pp
fi || :

%posttrans selinux
%selinux_relabel_post
exit 0

%posttrans
# when upgrading from R4.0, %%postun of qubes-core-agent-qrexec will revert
# %%post of this package. Redo the action in %%posttrans
%systemd_post qubes-qrexec-agent.service
# and then start it back
if systemctl is-enabled qubes-qrexec-agent.service >/dev/null 2>&1; then
    systemctl start qubes-qrexec-agent.service
fi

%files
%defattr(-,root,root,-)
%config(noreplace) /etc/pam.d/qrexec
%dir /etc/qubes/rpc-config
/etc/qubes/rpc-config/README

%{_bindir}/qrexec-client-vm
%{_bindir}/qrexec-fork-server

%{_mandir}/man1/qrexec-client-vm.1*

/usr/lib/qubes/qrexec-agent
/usr/lib/qubes/qrexec-client-vm
/usr/lib/qubes/qrexec_client_vm
/lib/systemd/system/qubes-qrexec-agent.service

%files selinux
%{_datadir}/selinux/devel/include/contrib/ipp-qubes-core-qrexec.if
%{_datadir}/selinux/packages/qubes-core-qrexec.pp

%changelog
* Thu May 11 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b1007c3
- version 4.2.6

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 322bcf6
- daemon: fix off-by-one in MSG_TRIGGER_SERVICE3 validation

* Sun May 07 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 32501cd
- Do not use 'annotation' future extension

* Wed May 03 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 69a21b7
- version 4.2.5

* Sat Apr 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0ab2ac1
- Avoid having qrexec-policy-daemon handle connections

* Sat Apr 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 721767c
- Use pytest_asyncio.fixture() for async test fixtures

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6e6226a
- Add types to Python code

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 8df2627
- qrexec-client: Allow killing the VM before exiting

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 36da281
- Add new utility functions to libqrexec

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6a00e92
- avoid option injection in 'make clean'

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 93a0b39
- Clean up gcov cruft in 'make clean'

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c97ad3a
- Fix make install when already installed

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f84f578
- Fix some mypy errors

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 975a980
- Forcibly rebuild C code for socket tests

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 82483ef
- Avoid option injection for usernames starting with "-"

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 721c34f
- Add missing static

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 59e65f0
- Add a missing #include

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ace6261
- More consistency checks in buffer code

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b7851c8
- Correctly detect SOCK_CLOEXEC

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - af828db
- Slightly better validation of data from dom0

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b404a66
- Fix reserved identifier violations

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - cd784de
- Avoid K&R function declarations

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5b678d9
- Ensure all data is sent to policy daemon

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 7de0f06
- Ignore stopped or continued children

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a1cfe66
- Fix signal handling bugs

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 1e3d0c9
- Check return value of snprintf()

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e796a2a
- Use close_range(2) instead of manual close loop

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 65d8581
- Check the return value of strdup()

* Wed Apr 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 79e02cf
- version 4.2.4

* Fri Apr 14 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2d1baa9
- Switch to new codecov uploader

* Sat Apr 01 2023 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 3dfeab6
- Rework Archlinux packaging

* Sat Feb 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 48c19ec
- Fix policy permissions on upgrade too

* Thu Feb 16 2023 Maja Kądziołka <maya@invisiblethingslab.com> - de25326
- Fix man page format

* Sat Jan 28 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e8bb6c3
- version 4.2.3

* Fri Jan 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cb9d358
- Make pylint happy

* Fri Jan 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 40f963b
- Do not call asyncio.get_event_loop() before creating one

* Thu Jan 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c04f719
- Wrap coroutine in a task before passing to asyncio.wait

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2160b2e
- version 4.2.2

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 78a5b5c
- debian: drop explicit dependency on libvchan-xen

* Fri Dec 30 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9bcb82b
- version 4.2.1

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e35bd85
- Allow qrexec to connect to any socket

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 43941bf
- Allow qrexec to connect to anything

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f5f146
- try to fix more denials

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2284438
- fix for systemd selinux rules

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 15b6af2
- Allow qrexec to start systemd services

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5a064f8
- Try to fix an SELinux denial

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a28c135
- Avoid running /bin/sh as local_login_t

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 20ff3db
- Set SELinux context in qrexec too

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6d480c1
- Set agent SELinux context in systemd unit file

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 58f9450
- Allow qrexec to exec systemctl

